{
                      A sikbeli gz szimulcis modell.
  Programspecifikci:
    Input:
         paramterek - N,M reakcitr-mretek
                       K az elhelyezend rszecskk szma
                       G gravitcis egytthat
         tjkoztat fjlok sorokra trdelve
         beavatkozs - billentykkel (nagy s kisbetk nem klnbznek)
                       'c' = csendes zemmd;      'n' = norml  zemmd;
                       'l' = lpsenknti zemmd; 'v' = vge
    Output:
         karakteres kpernyn = tjkoztat lapozott szvege
         grafikus kpernyn   = reakcitr
                                grafikonablakok:
                                1. Eloszls (a baloldali fal egyes cellinak
                                   eddig tkz rszecskk szma)
                                2. Iddiagram (a balaoldali falra hat ssz
                                   nyoms, azaz az utols 'idoDiagValt' id-
                                   egysgben a bal falat rt tkzsek szma)
}
Program Szimulacio;

{ -------------------------------------------------------------------------
        Szimulcis program. (A fizikai... szimulcihoz.)

        Megoldsprogram.
  ------------------------------------------------------------------------- }
  Uses
{$IFDEF FPC --FreePascal}
    Crt,
{$ELSE -- TurboPascal}
    Newdelay,Crt,
{$ENDIF}
    Graph,Ablakok;
  Const
    Fejlec         = ' Gz ';
    TajekoztatoFajl= 'gazszim.hlp';
    KonkluzioFajl  = 'gazszim.sum';

  Const
    IdoDiagValt = 2000; {ennyi idegysgenknt rajzolja az idDiagramot
                         osszUtk-t ennyi idre szmolja}
  Var
    {Ablakok: ---------------------------------------------------------}
    TerAblak: TAblak;     {Reakcitr}
    KarAblak: TKarAblak;  {Karakteres informcik}
    Graf1,
    Graf2   : THisztAblak;{Hisztogramok}
    {Szimulcis adatok: paramterek ----------------------------------}
    T       : LongInt;
    N,M,K   : Integer;
    ReaTer  : TReaTer;
    G       : Real;    {gravitcis egytthat}
    voltUtk : Boolean; {volt-e tkzs ebben az idegysgben a bal falon?}
    utkY    : Integer; {ha volt tkzs, akkor ebben a magassgban}
    osszUtk : LongInt; {az tkzsek ssz szma}
    s       : String;

  {A lnyegi eljrsok s fggvnyek: ---------------------------------------}

  Procedure Inicializalas;
    {Paramterbeolvass
     Grafikon-parametrizls
     Esemnytr inicializlsa}
    Var
      i,j,
      gd,gm:Integer;
      s:String;
  Begin
      {Paramterbeolvass innen hinyzik: N,M,K,Ah,Kh,G,rSz rtke}
    SzovegesLap(Fejlec);
      {reakcitr fggleges mrete -- N beolvassa:}
    Repeat
      Write('A reakcitr fggleges mrete? [1-',MaxN,']');
      Readln(N);
    Until N in [1..MaxN];
      {reakcitr vzszintes mrete -- M beolvassa:}
    Repeat
      Write('A reakcitr vizszintes mrete? [1-',MaxM,']');
      Readln(M);
    Until M in [1..MaxM];
      {rszecsketmb ngyzetnek oldalhossza -- K beolvassa:}
    Repeat
      Write('A rszecsketmb ngyzetnek oldalhossza [1-',M Div 3,']');
      Readln(K);
    Until (K<=M Div 3) and (K>0);
      {gravitci -- G beolvassa:}
    Repeat
      Write('A gravitci nagysga (lefel lps valszinsge) ? [-1..1]');
      Readln(G);
    Until (G>=-1) and (G<=1);
    osszUtk:=0; {0 volt az eddigi ssz tkzs}

      {Ablak-parametrizls innen hinyzik (grafikafggen irand meg!),
       a grafikus ablakot meg kell nyitni:}
    gd:=Detect; InitGraph(gd,gm,Path); ClearViewPort; {csak ideiglenesen!}
    ReaAblakLetrehozas(TerAblak,
                       TP2FP_X(10),TP2FP_Y(20),
                       TP2FP_X(310),TP2FP_Y(240),
                       'Reakcitr',White);
    KarAblakLetrehozas(KarAblak,
                       TP2FP_X(320),TP2FP_Y(20),
                       TP2FP_X(630),TP2FP_Y(240),
                       'Informcik',White);
    KarAblakUjMezo(KarAblak,'zemmd',SUzemModok[UzemMod]);
    Str(N,s); KarAblakUjMezo(KarAblak,'N',s);
    Str(M,s); KarAblakUjMezo(KarAblak,'M',s);
    Str(K,s); KarAblakUjMezo(KarAblak,'K',s);
    Str(G:0:0,s); KarAblakUjMezo(KarAblak,'G',s);
    KarAblakUjMezo(KarAblak,'ssz-tkzs','0');
    AblakLetrehozas(Graf1,
                    TP2FP_X(10),TP2FP_Y(250),
                    TP2FP_X(310),TP2FP_Y(460),
                    'Nyoms-eloszls',
                    N+1,5,White);
    Str(IdoDiagValt,s);
    AblakLetrehozas(Graf2,
                    TP2FP_X(320),TP2FP_Y(250),
                    TP2FP_X(630),TP2FP_Y(460),
                    'Nyoms-vltozs '+s+' idegysgenknt',
                    0,TP2FP_Y(460-250-20)/N,White);
    CloseGraph; {grafikus zemmd lezrva!}

       {Esemnytr inicializlsa innen hinyzik:}
       {szimulcis tr generlsa:
        * ressel feltlts
        * falallal krbevtel
        * K db vletlen elhelyezs bellre}
    For i:=0 to MaxN+1 do For j:=0 to MaxM+1 do
    Begin
      ReaTer[i,j]:=Ures
    End;
    For j:=0 to M+1 do
    Begin
      ReaTer[0,j]:=Fal; ReaTer[N+1,j]:=Fal;
    End;
    For i:=1 to N do
    Begin
      ReaTer[i,0]:=Fal; ReaTer[i,M+1]:=Fal;
    End;
    //a bal sarokhoz kzel, de nem rtapadva a Rszecske-tmb:
    For i:=1 to K do
    Begin
      For j:=1 to K do
      Begin
        ReaTer[i,j]:=Reszecske;
      End;
    End;
    osszUtk:=0; {0 volt az eddigi ssz tkzs}
  End; {Inicializalas}

  Procedure KezdoKepernyo;
    {Grafikus kp inicializlsa:
     * CimAblak: cim kiirasa
     * IdAblak: T kirsa
     * HalpAblak: Help-sor kirsa
     * GrafikonAblakok: resen
     * EsemnyTrAblak: kezd llapotban}
    Var
      gd,gm:Integer;
  Begin
    {A grafikus kp inicializlsa:}
    If KepMod<>Grafikus then 
    Begin
      KepMod:=Grafikus;
      gd:=Detect; InitGraph(gd,gm,Path); ClearViewPort;
      SetTextJustify(LeftText,TopText);
    End;
    GrafikusKepernyoAllandoReszei(Fejlec);
      {GrafikonAblakok:}
    AblakRajzolas(Graf1);
    AblakRajzolas(Graf2);
      {RekaciTrAblak:}
    ReaTerAblakRajzolas(TerAblak);
    ReaTerUjraRajzol(TerAblak,ReaTer,N,M,T);
      {KarakteresAblak:}
    KarAblakRajzolas(KarAblak);
  End; {KezdoKepernyo}

  Procedure SzimulaciosLepes;
    {A lnyeg:
     1. (i,j):=vletlen hely
     2. (ii,jj):=vletlen szomszdos hely
     3. ha megfelelk((i,j,(ii,jj),SzomszdSzm) akkor
        3.1. csere(ReaTer(i,j),ReaTer(ii,jj))
        3.2. ha kell akkor RszecskeRajzolsok
        3.3. tkzs adminisztrls: voltUtk, utkY
    }
    Var
      i,j,
      ii,jj: Integer;
      R    : Real;
  Begin
       {A lnyeg innen hinyzik:}
    (*ide kell a kd*)
  End; {SzimulaciosLepes}

  Procedure EredmenyMegjelenites;
    Var
      s:String;
  Begin
    FoIdoKiiras({FoAblak,}T);
      {Grafikonok:}
    If voltUtk then
    Begin
      EloszlasFv(utkY,Graf1,T);
    End;
    //a nem "ssz-tkzs szmts" "nagy idegysgenknt", de akr lpsenknt is kirand:
    If ((T Mod IdoDiagValt)=0) or (UzemMod=Lepesenkenti) then
    Begin
      //Bal falra hat nyoms eloszlsnak a frisstse:
      TeljesGrafikon(Graf1);
      IdoKiiras(Graf1,T);
      //Reakcitr frisstse:
      ReaTerUjraRajzol(TerAblak,ReaTer,N,M,T);
      ReaIdoKiiras(TerAblak,T);
      //Informcis tr frisstse:
      Str(osszUtk,s); KarAblakUjErtek(KarAblak,'ssz-tkzs',s);
      KarAblakUjErtek(KarAblak,'zemmd',SUzemModok[UzemMod]);
      KarAblakRajzolas(KarAblak);
      KarIdoKiiras(KarAblak,T);
    End;
    //az ssz-tkzs szmtsnak terminusa lejrt,
    //adminisztrland + rajzolhat:
    If (T Mod IdoDiagValt)=0 then
    Begin
      //Bal falra hat nyoms vltozsnak a frisstse:
      IdoDiagram(osszUtk,Graf2,T);
      //tabula rasa:
      osszUtk:=0;
    End;
  End; {EredmenyMegjelenites}

  Function VegeE: Boolean;
    Var
      c: Char;  
      RegiUzemMod: TUzemModok;
  Begin
    RegiUzemMod:=UzemMod;
    BillentyureVar(c);  {esetleges zemmdvlts}
    If (RegiUzemMod<>uzemMod) then
    Begin
      KarAblakUjErtek(KarAblak,'zemmd',SUzemModok[UzemMod]);
      KarAblakRajzolas(KarAblak);
      TeljesGrafikon(Graf1);
      IdoKiiras(Graf1,T);
//      TeljesGrafikon(Graf2); ezt az eredmnymegjelentskor mr kirajzoltam
//      IdoKiiras(Graf2,T);
      ReaTerUjraRajzol(TerAblak,ReaTer,N,M,T);
    End;
    If uzemMod in [Normal,Lepesenkenti] then ReaIdoKiiras(TerAblak,T);
    {$IFDEF FPC --FreePascal}
    If (RegiUzemMod=Csendes) and (uzemMod in [Normal,Lepesenkenti]) then
      Writeln('zemmdvlts: ',SUzemModok[UzemMod],' (',T,',',c,')');
    {$ENDIF}
    VegeE:=(UzemMod=Vege) {And (automatikus vgllapot rzkels)}
  End; {Vege}

  Procedure OsszefoglaloMegjelenites;
    {A konklzi szvegnek lapozott kirsa a kpernyre
     rszben (?) egy elre preparlt fjlbl,
     rszben (?) a szimulci esemnyfjljbl}
    Var
       c  : Char;
       s  : Byte; {a kirand sor sorszma}
       sor,       {a kirand sor szvege}
       sE,sK,sV: String[80];
       tf : Text;
    Procedure
      Szetszed(Const sor,minel:String; Var sE,sV:String);
      { Ef: minel RSZE sor
	  * Uf: sE,sV RSZE sor  S
      *     sor=sE+minel+sV
      }
        Var
         i:Byte;
      Begin
        i:=Pos(minel,sor);
        sE:=Copy(sor,1,i-1); sV:=Copy(sor,i+Length(minel),255); {255=vgig}
      End; {Szetszed}
    
  Begin
      {Az sszefoglal elre elksztett szvege, 
      * beillesztend "konkrtumokkal":
      * <@T@> -- vgid
      * <@N@> -- N-paramter: ...
      * <@K@> -- K-paramter: ...
      * }
    KepMod:=Szoveges; CloseGraph;
    SzovegesLap(Fejlec); 
    BillentyureVar(c);
    Assign(tf,KonkluzioFajl);
    {$i-}
    Reset(tf);
    {$i+}
    If IOResult=0 then
    Begin
      While not Eof(tf) do
      Begin
        SzovegesLap(Fejlec); s:=1;
        Repeat
          If s>1 then Writeln; 
          Readln(tf,sor);
          While Pos('<@T@>',sor)>0 do
          Begin
            Szetszed(sor,'<@T@>',sE,sV); 
            Str(T,sK);
            sor:=sE+sK+sV;
          End;
          While Pos('<@N@>',sor)>0 do
          Begin
            Szetszed(sor,'<@N@>',sE,sV); 
            Str(N,sK);
            sor:=sE+sK+sV;
          End;
          While Pos('<@K@>',sor)>0 do
          Begin
            Szetszed(sor,'<@K@>',sE,sV); 
            Str(K,sK);
            sor:=sE+sK+sV;
          End;
          Write(sor); Inc(s)
        Until Eof(tf) or (s=20);
        BillentyureVar(c);
      End; {While}
      Close(tf);
    End
      Else
    Begin
      HighVideo; Writeln('  Nincs meg az sszefoglal fjl!!!  '); NormVideo;
      BillentyureVar(c)
    End; {If IOResult}
    ClrScr; GotoXY(25,10); Writeln('Itt a vge fuss el vle!!!!');
  End; {OsszefoglaloMegjelenites}

  {--------------------------------------- A lnyegi eljrsok s fggvnyek}

Begin
  UzemMod:=Lepesenkenti;
  Tajekoztato(Fejlec,TajekoztatoFajl);
  Inicializalas; T:=0;
  KezdoKepernyo;
  EredmenyMegjelenites;
  While not VegeE do
  Begin
    Inc(T);
    SzimulaciosLepes;
    EredmenyMegjelenites;
  End;
  OsszefoglaloMegjelenites;
End.
